Prime Path(bfs)

A - Prime Path(11.1.1)
Time Limit:1000MS     Memory Limit:65536KB     64bit IO Format:%I64d & %I64u

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime. 

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0


#include<iostream>
using namespace std;


typedef class
{
public:
int prime;
int step;
}number;


bool JudgePrime(int digit)
{
if(digit==2 || digit==3)
return true;
else if(digit<=1 || digit%2==0)
return false;
else if(digit>3)
{
for(int i=3;i*i<=digit;i+=2)
if(digit%i==0)
return false;
return true;
}
}


int a,b;
bool vist[15000];
number queue[15000];


void BFS(void)
{
int i;  //temporary
int head,tail;
queue[head=tail=0].prime=a;
queue[tail++].step=0;
vist[a]=true;


while(head<tail)
{
number x=queue[head++];
if(x.prime==b)
{
cout<<x.step<<endl;
return;
}


int unit=x.prime%10;       //获取x的个位
int deca=(x.prime/10)%10;  //获取x的十位


for(i=1;i<=9;i+=2)     //枚举x的个位,保证四位数为奇数(偶数必不是素数)
{
int y=(x.prime/10)*10+i;
if(y!=x.prime && !vist[y] && JudgePrime(y))
{
vist[y]=true;
queue[tail].prime=y;
queue[tail++].step=x.step+1;
}
}
for(i=0;i<=9;i++)     //枚举x的十位
{
int y=(x.prime/100)*100+i*10+unit;
if(y!=x.prime && !vist[y] && JudgePrime(y))
{
vist[y]=true;
queue[tail].prime=y;
queue[tail++].step=x.step+1;
}
}
for(i=0;i<=9;i++)     //枚举x的百位
{
int y=(x.prime/1000)*1000+i*100+deca*10+unit;
if(y!=x.prime && !vist[y] && JudgePrime(y))
{
vist[y]=true;
queue[tail].prime=y;
queue[tail++].step=x.step+1;
}
}
for(i=1;i<=9;i++)     //枚举x的千位,保证四位数,千位最少为1
{
int y=x.prime%1000+i*1000;
if(y!=x.prime && !vist[y] && JudgePrime(y))
{
vist[y]=true;
queue[tail].prime=y;
queue[tail++].step=x.step+1;
}
}


}


cout<<"Impossible"<<endl;
return;
}


int main(void)
{
int test;
cin>>test;
while(test--)
{
cin>>a>>b;
memset(vist,false,sizeof(vist));
BFS();
}
return 0;
}



先说一下bfs吧,,就是广搜,宽搜,

比如这一题,首先拿第一格例子,,1033 8179;

设一个数初始1033,当等于8179时,说明能结束了;

首先搜1033中只更改一个数的,,,并记下此时到达该数的步数

是(排除1033本身)

1031  1
1039 1
1013 1
1063 1
1093 1
1433 1
1733 1
1933 1



第二步,再分别对这8个数进行广搜   (再次搜索时排除这9个数),这时这些数搜到的数的步数都为2;

第三步,重复第二步

。。。。。

此时,谁先到达8197,他所代表的步数即为最小步数,输出,结束。

原文地址:https://www.cnblogs.com/lengxia/p/4387806.html